xfstests: fix some warnings
[xfstests-dev.git] / common.config
1 ##/bin/bash
2 #
3 # Copyright (c) 2000-2003,2006 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # This program is free software; you can redistribute it and/or
6 # modify it under the terms of the GNU General Public License as
7 # published by the Free Software Foundation.
8 #
9 # This program is distributed in the hope that it would be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write the Free Software Foundation,
16 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
17 #
18 #
19 # setup and check for config parameters, and in particular
20 #
21 # EMAIL -           email of the script runner.
22 # TEST_DIR -        scratch test directory that is in an already
23 #                   mounted XFS file system, needs to be be world
24 #                   writeable
25 # TEST_DEV -        device for file system containing TEST_DIR
26 #
27 # and optionally:
28 # SCRATCH_DEV -     device you can make a scratch file system on
29 # SCRATCH_MNT -     mount point for scratch file system
30 # SCRATCH_LOGDEV -  scratch log device for external log testing
31 # SCRATCH_RTDEV -   scratch rt dev
32 # TEST_LOGDEV -     test log device for external log testing
33 # TEST_RTDEV -      test rt dev
34 # TAPE_DEV -        the tape device for the xfsdump tests
35 # RMT_TAPE_DEV -    the remote tape device for the xfsdump tests
36 # RMT_IRIXTAPE_DEV- the IRIX remote tape device for the xfsdump tests
37 # RMT_TAPE_USER -   remote user for tape device
38 #
39 # - These can be added to $HOST_CONFIG_DIR (witch default to ./config)
40 #   below or a separate local configuration file can be used (using
41 #   the HOST_OPTIONS variable).
42 # - This script is shared by the stress test system and the auto-qa
43 #   system (includes both regression test and benchmark components).
44 # - TEST_DEV & TEST_DIR must be assigned.
45 # - this script shouldn't make any assertions about filesystem
46 #   validity or mountedness.
47 #
48
49 # all tests should use a common language setting to prevent golden
50 # output mismatches.
51 export LANG=C
52
53 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
54 #  get the wrong hostname and set your system name to -s  :)
55 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
56 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
57 PATH=".:$PATH"
58
59 HOST=`hostname -s`
60 HOSTOS=`uname -s`
61 [ "$HOSTOS" = "IRIX64" ] && HOSTOS="IRIX"
62
63 MODULAR=0               # using XFS as a module or not
64 BOOT="/boot"            # install target for kernels
65 export EXTRA=${EXTRA:=xfs-qa}
66
67 # general parameters (mainly for auto-qa)
68 SOAK_PROC=3             # -p option to fsstress
69 SOAK_STRESS=10000       # -n option to fsstress
70 SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
71 EMAIL=root@localhost    # where auto-qa will send its status messages
72 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
73 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
74 export BENCH_PASSES=${BENCH_PASSES:=5}
75 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
76
77 export PWD=`pwd`
78 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
79 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
80 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
81
82 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
83 set_prog_path()
84 {
85     p=`which $1 2> /dev/null`
86     if [ -n "$p" -a -x "$p" ]; then
87         echo $p
88         return 0
89     fi
90     p=$1
91
92     shift
93     for f; do
94         if [ -x $f ]; then
95             echo $f
96             return 0
97         fi
98     done
99
100     echo ""
101     return 1
102 }
103
104 _fatal()
105 {
106     echo "$*"
107     status=1
108     exit 1
109 }
110
111 export MKFS_PROG="`set_prog_path mkfs`"
112 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
113
114 export MOUNT_PROG="`set_prog_path mount`"
115 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
116
117 export UMOUNT_PROG="`set_prog_path umount`"
118 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
119
120 export FSSTRESS_PROG="`set_prog_path fsstress $PWD/ltp/fsstress`"
121 [ "$FSSTRESS_PROG" = "" ] && _fatal "fsstress not found"
122
123 export PERL_PROG="`set_prog_path perl`"
124 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
125
126 export AWK_PROG="`set_prog_path awk`"
127 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
128
129 export SED_PROG="`set_prog_path sed`"
130 [ "$SED_PROG" = "" ] && _fatal "sed not found"
131
132 export BC_PROG="`set_prog_path bc`"
133 [ "$BC_PROG" = "" ] && _fatal "bc not found"
134
135 export PS_ALL_FLAGS="-ef"
136
137 export DF_PROG="`set_prog_path df`"
138 [ "$DF_PROG" = "" ] && _fatal "df not found"
139 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T"
140
141 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
142 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
143 export XFS_CHECK_PROG="`set_prog_path xfs_check`"
144 export XFS_DB_PROG="`set_prog_path xfs_db`"
145 export XFS_GROWFS_PROG=`set_prog_path xfs_growfs`
146 export XFS_IO_PROG="`set_prog_path xfs_io`"
147 export XFS_PARALLEL_REPAIR_PROG="`set_prog_path xfs_prepair`"
148 export XFS_PARALLEL_REPAIR64_PROG="`set_prog_path xfs_prepair64`"
149 export XFSDUMP_PROG="`set_prog_path xfsdump`"
150 export XFSRESTORE_PROG="`set_prog_path xfsrestore`"
151 export XFSINVUTIL_PROG="`set_prog_path xfsinvutil`"
152
153 # Generate a comparable xfsprogs version number in the form of
154 # major * 10000 + minor * 100 + release
155 #
156 # $ xfs_db -V
157 # xfs_db version 2.9.7
158 #
159 # so, 2.9.7 = 20907
160 _version=`$XFS_DB_PROG -V | $AWK_PROG '
161         /version/ {
162                 if (split($3,ver,".") == 3)
163                         print (ver[1] * 10000) + (ver[2] * 100) + ver[3];
164         }'`
165 [ -z "$_version" ] && _fatal "xfsprogs version cannot be found"
166 export XFSPROGS_VERSION="$_version"
167
168 case "$HOSTOS" in
169     IRIX*)
170         export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
171         export MKFS_UDF_PROG="`set_prog_path mkfs_udf`"
172         export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
173         export MKFS_NFS_PROG="false"
174         ;;
175     Linux)
176         export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
177         export MKFS_UDF_PROG="`set_prog_path mkudffs`"
178         export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
179         export MKFS_NFS_PROG="false"
180         ;;
181 esac
182
183 known_hosts()
184 {
185   [ "$HOST_CONFIG_DIR" ] || HOST_CONFIG_DIR=`pwd`/configs
186
187   [ -f /etc/xfsqa.config ]             && . /etc/xfsqa.config
188   [ -f $HOST_CONFIG_DIR/$HOST ]        && . $HOST_CONFIG_DIR/$HOST
189   [ -f $HOST_CONFIG_DIR/$HOST.config ] && . $HOST_CONFIG_DIR/$HOST.config
190
191   #  Mandatory Config values.
192   MC=""
193   [ -z "$EMAIL" ]          && MC="$MC EMAIL"
194   [ -z "$TEST_DIR" ]       && MC="$MC TEST_DIR"
195   [ -z "$TEST_DEV" ]       && MC="$MC TEST_DEV"
196
197   if [ -n "$MC" ]; then
198     echo "Warning: need to define parameters for host $HOST"
199     echo "       or set variables:"
200     echo "       $MC"
201     exit 1
202   fi
203 }
204
205 if [ -f "$HOST_OPTIONS" ]; then
206     . "$HOST_OPTIONS"
207 else
208     known_hosts
209 fi
210
211 echo $TEST_DEV | grep -q ":" > /dev/null 2>&1
212 if [ ! -b "$TEST_DEV" -a "$?" != "0" ]; then
213     echo "common.config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a NFS filesystem"
214     exit 1
215 fi
216
217 if [ ! -d "$TEST_DIR" ]; then
218     echo "common.config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
219     exit 1
220 fi
221
222 echo $SCRATCH_DEV | grep -q ":" > /dev/null 2>&1
223 if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]; then
224     echo "common.config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a NFS filesystem"
225     exit 1
226 fi
227
228 if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]; then
229     echo "common.config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
230     exit 1
231 fi
232
233 _readlink()
234 {
235     if [ $# -ne 1 ]; then
236         echo "Usage: _readlink filename" 1>&2
237         exit 1
238     fi
239
240     perl -e "\$in=\"$1\";" -e '
241     $lnk = readlink($in);
242     if ($lnk =~ m!^/.*!) {
243         print "$lnk\n";
244     }
245     else {
246         chomp($dir = `dirname $in`);
247         print "$dir/$lnk\n";
248     }'
249 }
250
251 # if devfs is running expand the full /dev/.. pathname - this is what will be
252 # returned by utilities such as mount
253 [ -L "$TEST_DEV" ] && TEST_DEV=`_readlink $TEST_DEV`
254 [ -L "$SCRATCH_DEV" ] && SCRATCH_DEV=`_readlink $SCRATCH_DEV`
255 [ -L "$SCRATCH_LOGDEV" ] && SCRATCH_LOGDEV=`_readlink $SCRATCH_LOGDEV`
256 [ -L "$SCRATCH_RTDEV" ] && SCRATCH_RTDEV=`_readlink $SCRATCH_LOGDEV`
257
258 # make sure this script returns success
259 /bin/true